=== debian/changelog ===
clam-chordata (1.0.0-2) unstable; urgency=low

  * debian/control: add libdevel packages to Build-Depends. (Closes: #621394)
  * debian/control: Change Maintainer to Debian Multimedia Team

 -- TANIGUCHI Takaki <takaki@debian.org>  Thu, 14 Apr 2011 20:18:38 +0900

clam-chordata (1.0.0-1) unstable; urgency=low

  * Initial release (Closes: #517910)

 -- TANIGUCHI Takaki <takaki@debian.org>  Fri, 28 Jan 2011 13:02:49 +0900
