=== debian/control ===
Source: clam-chordata
Section: sound
Priority: extra
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: TANIGUCHI Takaki <takaki@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
	scons,
	libclam-dev (>= 1.4.0-2),
	libclam-qtmonitors-dev,
	libqt4-dev,
	libqt4-opengl-dev,
Standards-Version: 3.9.1
Homepage: http://clam-project.org/
#Vcs-Git: git://git.debian.org/collab-maint/clam-chordata.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/clam-chordata.git;a=summary

Package: clam-chordata
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CLAM Chordata, chord detection tool
 CLAM Chordata is a chord detection tool that can be used to browse the
 chords of your favourite mp3/ogg/wav music. You can freely move arround
 the song, listening and getting insight of its tonal features by using
 several available views: Chord segments, Chord ranking, Tonnetz,
 Keyspace, Chromatic peaks, PCPgram...
 .
 This is an example application of the CLAM framework.
