=== debian/watch ===
version=3
http://clam-project.org/download/src/ chordata-(.*)\.tar\.gz
